function [finalPeakValue, finalPeakLocation] = composatePeakForLine(zLine, deviationValue, estimation, previousPoint)
%UNTITLED Summary of this function goes here
%   Detailed explanation goes her
% Get the peak estimation
%[peakValueEstimation, peakLocationEstimation] = max(zLine);

if(nargin == 2)
    [finalPeakValue, finalPeakLocation] = max(zLine); 
else
    
    [peakValueEstimationArray, peakLocationEstimationArray] = findpeaks(double(zLine),'SortStr','descend','MinPeakDistance',0.1, 'npeaks', 3);

    % No Results
    if(isempty(peakLocationEstimationArray))
        [peakValueEstimation, peakLocationEstimation] = max(zLine);

        % One Result
    elseif(length(peakLocationEstimationArray) == 1)
        peakValueEstimation = peakValueEstimationArray;
        peakLocationEstimation = peakLocationEstimationArray;
        
        % More Results
    else
        firstPeak = estimation(:,peakLocationEstimationArray(1));
        peakDistance = pdist2(firstPeak', previousPoint');
        candidatePeak = 1;
        for foundPeak = 2:length(peakLocationEstimationArray)
            newPeakDistance = pdist2(estimation(:,peakLocationEstimationArray(foundPeak))', previousPoint');
            if(peakDistance > newPeakDistance)
               candidatePeak = foundPeak;
               peakDistance = newPeakDistance;
            end
        end
        peakValueEstimation = peakValueEstimationArray(candidatePeak);
        peakLocationEstimation = peakLocationEstimationArray(candidatePeak);
        
        
    end

    % Fill a temporary array
    possibleNewPeaks = [peakValueEstimation];
    comparingValue = peakValueEstimation;
    for i = peakLocationEstimation : -1 : 1
        if(abs(comparingValue - zLine(i)) <= deviationValue)
            possibleNewPeaks = [i possibleNewPeaks];
        else
            break;
        end
        comparingValue = zLine(i);
    end
    
    comparingValue = peakValueEstimation;
    for i = peakLocationEstimation : length(zLine)
        if(abs(comparingValue - zLine(i)) <= deviationValue)
            possibleNewPeaks = [possibleNewPeaks i];
        else
            break;
        end
        comparingValue = zLine(i);
    end

   finalPeakValue = peakValueEstimation;
   finalPeakLocation = peakLocationEstimation;
   % finalPeakLocation = round(mean(possibleNewPeaks));
   % finalPeakValue = zLine(finalPeakLocation);
end
    
% peakValueEstimationArray = [];
% 
% if(isempty(peakLocationEstimationArray))
%     
%     [peakValueEstimation, peakLocationEstimation] = max(zLine);
%     
% elseif(length(peakLocationEstimationArray) > 1)
%         closestToMiddleArray = abs(peakLocationEstimationArray - 0.5.*length(zLine));
%         [~, middleLocation] = min(closestToMiddleArray);
%         peakValueEstimation = peakLocationEstimationArray(middleLocation);
%         peakLocationEstimation = closestToMiddleArray(middleLocation);
%         
% else
%     peakValueEstimation = peakValueEstimationArray;
%     peakLocationEstimation = peakLocationEstimationArray;
%     
% end
% 
% % Fill a temporary array
% possibleNewPeaks = [peakValueEstimation];
% 
% comparingValue = peakValueEstimation;
% for i = peakLocationEstimation : -1 : 1
%     if(abs(comparingValue - zLine(i)) <= deviationValue)
%         possibleNewPeaks = [i possibleNewPeaks];
%     else
%         break;
%     end
%     comparingValue = zLine(i);
% end
% 
% comparingValue = peakValueEstimation;
% for i = peakLocationEstimation : length(zLine)
%     if(abs(comparingValue - zLine(i)) <= deviationValue)
%         possibleNewPeaks = [possibleNewPeaks i];
%     else
%         break;
%     end
%     comparingValue = zLine(i);
% end
% 
% finalPeakLocation = round(mean(possibleNewPeaks));
% finalPeakLocation
% finalPeakValue = zLine(finalPeakLocation);
% 
% finalPeakValue = zLine(peakLocationEstimation);
end

