function alveolus = generateAlveolusLine(estimation, searchLine, model, opcode )
%GENERATEALVEOLUSLINE Summary of this function goes here
%   Detailed explanation goes here

% Fill the first point

alveolus_raw = estimation(1,:);
startLarge = round(length(estimation) / 5);
endLarge = length(estimation) - round(length(estimation)/  5);

% Loop through each point 
for rcI = 2:length(estimation)
    
    % Get 2 points from the start of the list
    p1 = estimation(rcI-1, 1:2);
    p2 = estimation(rcI, 1:2);
    
    % If the two points are the same, no perpendicular line can be
    % determined, therefore skip it.
    if(p1 == p2)
        continue;
    end
    
    % Get the perpendicular line
    [middle,tA ,tB] = getPerp(p1,p2);
    
    % Create the line, and add some length to it.

    linCorrected =  2*cosd(atand(tA));
    if(rcI > startLarge && rcI < endLarge)
        linCorrected =  4*cosd(atand(tA));
    end
    
    
    % Get the X and Y components of the line
    x = double(linspace(middle(1) - linCorrected, middle(1) + linCorrected, 1000));
    y = tA .* x + tB;
    
    % In the perpendicular line, use raycasting to create a model of the
    % alveolus slice on this location
    coordsLine = double(rayCastLine(opcode, x, y));
    
  %  plot3(coordsLine(1,:), coordsLine(2,:), coordsLine(3,:))
    
    if(rcI > 2)
        [pks, peakLocs ] = get_HeighPoint_Maxilla(coordsLine, 0.01, estimation(rcI, :)',alveolus_raw(end, : )');
    else
        [pks, peakLocs ] = get_HeighPoint_Maxilla(coordsLine, 0.01, estimation(rcI, :)', estimation(rcI, :)');
    end
    
    alveolus_raw = [alveolus_raw; coordsLine(:, peakLocs)'];
    
  
end

alveolus = alveolus_raw;
end

