function [ initialLine ] = generateInitialLine(coords, model)

% Generate the T to TC lines
est_ttc1 = linspace3D(coords.t1, coords.tc1, 100);
est_ttc2 = linspace3D(coords.tc2, coords.t2, 100);

% Generate the TC to C 
est_tcc1= linspace3D(coords.tc1, coords.c1, 100);
est_tcc2 = linspace3D(coords.c2, coords.tc2, 100);

% Create the spline between TC1 and TC2
est_front= zeros(3, 1000);
est_front(1, :) = linspace(coords.c1(1), coords.c2(1), 1000);
est_front(2, :) = spline([coords.c1(1); coords.a1(1); coords.a2(1); coords.c2(1)], [coords.c1(2); coords.a1(2); coords.a2(2); coords.c2(2)], est_front(1,:));
est_front(3, :) = model.maxValues.z .* ones(1, 1000);
est_front = est_front';

est = [est_ttc1; est_tcc1; est_front; est_tcc2; est_ttc2];
est(:, 3) =  model.maxValues.z;

est(:, 1) =  sgolayfilt(est(:, 1) , 1, 21);
est(:, 2)  =  sgolayfilt(est(:, 2) , 1, 21);
est(:, 3) =  sgolayfilt(est(:, 3) , 1, 21);

initialLine = est;
end

