function [searchRange] = generateSearchLine( estimation, model )

% Now create the search range

coorMax = [];
coorMin = [];
startLarge = round(length(estimation) / 5);
endLarge = length(estimation) - round(length(estimation)/  5);

startSmall = 1;
endSmall = 80;

for ix = 1:length(estimation) - 1
    % Calculate the perpendicular line
    p1 = [estimation(ix, 1) estimation(ix, 2)];
    p2 = [estimation(ix+1 , 1) estimation(ix+1, 2)];
    
    % If the two points are the same, no perpendicular line can be
    % determined, therefore skip it.
    if(p1 == p2)
        counter = counter +  1;
        continue;
    end
    
    % Get the perpendicular line
    [middle,tA ,tB] = getPerp(p1,p2);
    
    % Create the line, and add some length to it.
    linCorrected =  3*cosd(atand(tA));
    if(ix > startLarge && ix < endLarge)
        linCorrected =  4*cosd(atand(tA));
    end
    
    if((ix > startSmall && ix < endSmall) || (length(estimation) - ix > startSmall && length(estimation) - ix < endSmall))
         linCorrected =  2.5*cosd(atand(tA));
    end
    

    
    % Print the line
    x = linspace(middle(1) - linCorrected, middle(1) + linCorrected, 1000);
    y = tA .* x + tB;
    
    centerPoint = 0.5 * [(model.maxValues.x + model.minValues.x) (model.maxValues.y + model.minValues.y)];
    
    % Check with side corresponds with the lower and upper constrain
    if(pdist2(centerPoint, [x(1) y(1)]) < pdist2(centerPoint, [x(end) y(end)]))
        coorMin(1, end+1) = x(1); coorMin(2,end) = y(1);
        coorMax(1, end+1) = x(end); coorMax(2, end) = y(end);
    else
        coorMax(1, end+1) = x(1); coorMax(2, end) = y(1);
        coorMin(1, end+1) = x(end); coorMin(2, end) = y(end);
    end

end

    
coorMin(3,:) = model.maxValues.z;
coorMax(3,:) = model.maxValues.z;




searchRange.min = coorMin';
searchRange.max = coorMax';

% Smooth the constrain
searchRange.min(:,1) = sgolayfilt(searchRange.min(:,1), 1, 21);
searchRange.min(:,2) = sgolayfilt(searchRange.min(:,2), 1, 21);
searchRange.min(:,1) = sgolayfilt(searchRange.min(:,1), 1, 21);
searchRange.min(:,2) = sgolayfilt(searchRange.min(:,2), 1, 21);

end

