function [finalPeakValue, finalPeakLocation] = get_HeighPoint_Maxilla(coords, maxDeviation, estimationPoint, previousPoint)

% Get the mean of the estimation and previous point
comparePoint = 0.5 .* (estimationPoint + previousPoint);

% Get the 5 most prominent peaks
[peakValueEstimationArray, peakLocationEstimationArray] = findpeaks(double(coords(3,:)),'SortStr','descend','MinPeakDistance',0.1, 'npeaks', 5);


% If no points are found, use the maximum z
if(isempty(peakLocationEstimationArray))
    [peakValueEstimation, peakLocationEstimation] = max(coords(3,:));
    % If only one peak is found
elseif(length(peakLocationEstimationArray) == 1)
    peakValueEstimation = peakValueEstimationArray;
    peakLocationEstimation = peakLocationEstimationArray;
else
    candidatePeak = 1;
    peakDistance = pdist2(comparePoint', coords(:, peakLocationEstimationArray(1))');
    
    for foundPeak = 2:length(peakLocationEstimationArray)
        newPeakDistance = pdist2(coords(:,peakLocationEstimationArray(foundPeak))', comparePoint');
        if(peakDistance > newPeakDistance)
            candidatePeak = foundPeak;
            peakDistance = newPeakDistance;
        end
    end
    
    peakValueEstimation = peakValueEstimationArray(candidatePeak);
    peakLocationEstimation = peakLocationEstimationArray(candidatePeak);
    
end

% Compensate for flat surfaces
possibleNewPeaks = [peakValueEstimation];
comparingValue = peakValueEstimation;
for i = peakLocationEstimation : -1 : 1
    if(abs(comparingValue - coords(3,i)) <= maxDeviation)
        possibleNewPeaks = [i possibleNewPeaks];
    else
        break;
    end
    comparingValue = coords(3,i);
end

comparingValue = peakValueEstimation;
for i = peakLocationEstimation : length(coords(3,i))
    if(abs(comparingValue - coords(3,i)) <= maxDeviation)
        possibleNewPeaks = [possibleNewPeaks i];
    else
        break;
    end
    comparingValue = coords(3,i);
end

finalPeakValue = peakValueEstimation;
finalPeakLocation = peakLocationEstimation;

end