function [heightMap, t] = makeHeightmapVertices(F, V, xPoints, yPoints, directionVec)
%MAKEHEIGHTMAPVERTICES Summary of this function goes here
%   Detailed explanation goes here

if(nargin < 5)
    directionVec = [0; 0; -1];
end

% Get the minimal and maximal values
[minValues, maxValues] = getBoundingBoxVertices(V);

% Get the opcode class
t = opcodemesh(V',F');

% Create an empty image
heightMap = zeros(xPoints, yPoints);

% Create the y map
yMap = linspace(minValues.y, maxValues.y, yPoints);
xMap = linspace(minValues.x, maxValues.x, xPoints);



[X,Y] = meshgrid(xMap,yMap);
Y = flipud(Y);
Z = 50*ones(size(X));
origin = [X(:) Y(:) Z(:)]';

direction = repmat(directionVec, 1, xPoints*yPoints);


[h,d,~,~,~] = t.intersect(origin, direction);

 

heightMap = reshape(d,yPoints,xPoints);

