function [V,  rotationMatrix]= rotateSTL(V, xAngle, yAngle, zAngle)

% Get the center of the object
minValues = [min(V(:,1)), min(V(:,2)), min(V(:,3))];
maxValues = [max(V(:,1)), max(V(:,2)), max(V(:,3))];
center = 0.5 .* (maxValues - minValues);

% Translate to the origin
Vorigin = V - repmat(center, length(V), 1);

% xRotation of 30
xRot = [cosd(xAngle) -sind(xAngle) 0; ...
    sind(xAngle) cosd(xAngle) 0; ...
    0 0 1];

% yRotation of 180
yRot = [1 0 0;...
    0 cosd(yAngle) -sind(yAngle);...
    0 sind(yAngle) cosd(yAngle)];

% zRotation of 12
zRot = [cosd(zAngle) 0 sind(zAngle);...
    0 1 0;...
    -sind(zAngle) 0 cosd(zAngle)];

% Combine them
rotationMatrix = xRot * yRot * zRot;


% Rotate 
VoriginRotated = (rotationMatrix * Vorigin')';

% Translate to the original place
V = VoriginRotated + repmat(center, length(V), 1);


