function [ coords ] = setTCPoint( coords , opcodeMesh, raycastLength, estimationPoints)
%% The following coordinates are adapted
%  TC1, TC2 are created

if(nargin < 3)
    raycastLength = 10;
    estimationPoints = 1000;
end

% Calculation of the TC points (points between the Tuber and cuspid points
middleTC1 = 0.3 * coords.t1 + 0.7 * coords.c1;
middleTC2 = 0.3 * coords.t2 + 0.7 * coords.c2;

% Raycast to the new landmark TC1
xLinespace = linspace(middleTC1(1) - raycastLength, middleTC1(1) + raycastLength, estimationPoints);
tempTC1 = rayCastLine(opcodeMesh, xLinespace, middleTC1(2) * ones(1, estimationPoints));

[finalPeakValue, finalPeakLocation] = composatePeakForLine(tempTC1(3,:), 0.01);
coords.tc1 = double([xLinespace(finalPeakLocation) middleTC1(2) finalPeakValue]);

% Raycast to the new landmark TC2
xLinespace = linspace(middleTC2(1) - raycastLength, middleTC2(1) + raycastLength, estimationPoints);
tempTC2 = rayCastLine(opcodeMesh, xLinespace,middleTC2(2) * ones(1,estimationPoints));
%plot3(tempTC1(1,:),tempTC1(2,:),tempTC1(3,:));
%plot3(tempTC2(1,:),tempTC2(2,:),tempTC2(3,:));
[finalPeakValue, finalPeakLocation ] = composatePeakForLine(tempTC2(3,:), 0.01);
coords.tc2 = double([xLinespace(finalPeakLocation) middleTC2(2) finalPeakValue]);


end

