function [ patchObject ] = showPatch(F, V, color)
%patchObject Show a 3D mesh 
%   input:
%   F = 3xn Faces
%   V = 3xn Vertices
%   color = 3x1 Double (0 between 1)


% Set default color
if(nargin ==  2)
    color = [0.95, 0.95, 0.95];
end

% Print the object
patchObject = patch('Faces', F, 'Vertices', V, 'EdgeColor', 'none', 'FaceColor', color);
hold on;

% Set lighting
lighting phong;

daspect([1 1 1]);

end

