function truncateULCPLine(src,event, side)

% Click 2 points
[r,c] = ginput(1);

coords = [r c];

assignin('base', 'coords', coords);
% find the closest locations
xLocLeft = evalin('base', 'xLocLeft');
yLocLeft = evalin('base', 'yLocLeft');
xLocRight = evalin('base', 'xLocRight');
yLocRight = evalin('base', 'yLocRight');


if(side == 'l')
    locs = [xLocLeft yLocLeft];
else
    
    locs = [xLocRight yLocRight];
end

searchBin = locs(:, 1:2);

%compute Euclidean distances:
distances = sqrt(sum(bsxfun(@minus, searchBin, coords(1,:)).^2,2));
%find the smallest distance and use that as an index into B:
[m1, sPoint] = min(distances);


if(length(locs) - sPoint < sPoint)
    % Remove the end part
    removal = locs(sPoint:end,:);
    locs(sPoint:end,:) = [];
else
    % Remove the start part
    removal = locs(1:sPoint,:);
    locs(1:sPoint,:) = [];
end


if(side == 'l')
    xLocLeft = locs(:,1);
    yLocLeft = locs(:,2);
else
    xLocRight = locs(:,1);
    yLocRight = locs(:,2);
end

%plot(removal(:,1), removal(:,2), 'c*');

plotLeft = evalin('base', 'pLeft');
delete(plotLeft);

plotRight = evalin('base', 'pRight');
delete(plotRight);

plotLeft = plot(xLocLeft, yLocLeft,'r*');
plotRight = plot(xLocRight, yLocRight,'b*');


assignin('base', 'xLocRight', xLocRight);
assignin('base', 'yLocRight', yLocRight);
assignin('base', 'xLocLeft', xLocLeft);
assignin('base', 'yLocLeft', yLocLeft);
assignin('base', 'pLeft', plotLeft);
assignin('base', 'pRight', plotRight);


end
