clear all; close all; clc;

dPath = '';
files = dir(fullfile(dPath, '*.mat'));

surgeryDate = load('');
surgeryDate = cell2mat(surgeryDate.box2surgery);

results = cell(length(files) + 1, 5);
results{1,1} = 'ID';
results{1,2} = 'Age';
results{1,3} = 'Cheilo';
results{1,4} = 'TT Distance';
results{1,5} = 'CC Distance';
results{1,6} = 'TT Depth';
results{1,7} = 'CC Depth';
results{1,8} = 'Cleft Width';
results{1,9} = 'Alveolar Length';
results{1,10} = 'Alveolar Length (large)';
results{1,11} = 'Alveolar Length (small)';
results{1,12} = '2D Area';

for idd = 1:length(files)
    fPath = fullfile(dPath, files(idd).name);
    disp(fPath);
    disp(idd);
    f = load(fPath, '-regexp', '^(?!opMesh|idd|results)\w');
    
    fName = files(idd).name;
    fName(strfind(fName, '.'):end) = [];
    fParts = strsplit(fName, '-');
    
    patName = fParts{1};
    y = str2double(fParts{2});
    m =str2double(fParts{3});
    d = str2double(fParts{4});
    totalDays = y*365+30*m+d;
    
    x1tt = f.fc.coords.t1;
    x2tt = f.fc.coords.t2;
    lineDirtt = (x2tt - x1tt) / norm(x2tt - x1tt);
    x0tt = f.fc.coords.frontal;
    
    vtt = x0tt - x1tt;
    dtt = dot(vtt, lineDirtt);
    stt = x1tt + dtt * lineDirtt ;
    
    x1cc = f.fc.coords.c1;
    x2cc = f.fc.coords.c2;
    lineDircc = (x2cc - x1cc) / norm(x2cc - x1cc);
    x0cc = f.fc.coords.frontal;
    
    vcc = x0cc - x1cc;
    dcc = dot(vcc, lineDircc);
    scc = x1cc + dcc * lineDircc;
       % Calculate the alveolus
    hm = f.fc.model.heightmap;
    z = 0;
    for iz = 1:length(f.xLocLeft)
        z(iz) = 50 - hm(round(f.yLocLeft(iz)), round(f.xLocLeft(iz)));
    end
     alLeft = [f.xMap(round(f.xLocLeft)); f.yMap(round(f.fc.options.heightmapYResolution - f.yLocLeft)); z];
     
     z = 0;
    for iz = 1:length(f.xLocRight)
        z(iz) = 50 - hm(round(f.yLocRight(iz)), round(f.xLocRight(iz)));
    end
    
    alRight = [f.xMap(round(f.xLocRight)); f.yMap(round(f.fc.options.heightmapYResolution - f.yLocRight)); z];
%     figure
%     
%     hold on;
%      plot3(alLeft(1,:), alLeft(2,:), alLeft(3,:));
%      plot3(alRight(1,:), alRight(2,:), alRight(3,:));
%      patch('vertices', fc.model.vertices, 'faces', fc.model.faces,'edgecolor','none', 'facecolor', [0.8 0.8 0.8]);
%      camlight;
%      lighting phong;
%     daspect([1 1 1]);
    
    
    d = diff(alLeft'); % EDIT
    total_length_left = sum(sqrt(sum(d.*d,2)));
    
    d = diff(alRight'); % EDIT
    total_length_right = sum(sqrt(sum(d.*d,2)));
    
    total_length = total_length_left + total_length_right;
    
    
    pID = str2double(patName);
    cheiloplastyDate = surgeryDate(find(surgeryDate(:,1) == pID),2);
    
 all = [alLeft alRight];


    
    results{idd+1, 1} = patName;
    results{idd+1, 2} = totalDays;
    if(cheiloplastyDate > totalDays)
        results{idd+1, 3} = 1;
    else
        results{idd+1, 3} = 0;
    end
    results{idd+1, 4} = pdist2(f.fc.coords.t1, f.fc.coords.t2);
    results{idd+1, 5} = pdist2(f.fc.coords.c1, f.fc.coords.c2);
    results{idd+1, 6} = pdist2(stt, f.fc.coords.frontal);
    results{idd+1, 7} = pdist2(scc, f.fc.coords.frontal);
    results{idd+1, 8} = pdist2(f.fc.coords.s1(1:2), f.fc.coords.s2(1:2));
    results{idd+1, 9} = total_length;
    if(total_length_left > total_length_right)
        results{idd+1, 10} = total_length_left;
        results{idd+1, 11} = total_length_right;
    else
        results{idd+1, 10} = total_length_right;
        results{idd+1, 11} = total_length_left;
    end
    results{idd+1, 12} = polyarea(all(1,:), all(2,:)) ;
    
end